
import UIKit
import CloudKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?
    
    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        let userSettings = UserDefaults.standard
        let values = ["subscriptionSaved": false, "zoneCreated": false]
        userSettings.register(defaults: values)
        
        application.registerForRemoteNotifications()
        AppData.configureDatabase(executeClosure: {})
        return true
    }
    func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) {
        let notification = CKNotification(fromRemoteNotificationDictionary: userInfo) as? CKDatabaseNotification
        if notification != nil {
            AppData.checkUpdates(finishClosure: { (result) in
                let mainQueue = OperationQueue.main
                mainQueue.addOperation({
                    completionHandler(result)
                })
            })
        }
    }
}
